Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.cs
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.cs	(revision 9086)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.cs	(revision 9087)
@@ -22,4 +22,5 @@
 using System;
 using System.Collections.Generic;
+using System.Drawing;
 using System.Linq;
 using System.Windows.Forms;
@@ -261,4 +262,31 @@
       Content.Modify();
     }
+
+    private void colorButton_Click(object sender, EventArgs e) {
+      string resultName = (string)dataTableComboBox.SelectedItem;
+      string rowName = (string)dataRowComboBox.SelectedItem;
+      var runs = Content.Where(x => x.Results.ContainsKey(resultName));
+      Dictionary<int, double> values = new Dictionary<int, double>();
+
+      if (stringConvertibleMatrixView.DataGridView.CurrentCell != null) {
+        int curIndex = stringConvertibleMatrixView.DataGridView.CurrentCell.ColumnIndex;
+
+        for (int i = 0; i < stringConvertibleMatrixView.Content.Rows; i++) {
+          values[i] = double.Parse(stringConvertibleMatrixView.Content.GetValue(i, curIndex));
+        }
+
+        var orderedValues = values.OrderBy(x => x.Value);
+
+        for (int i = 0; i < orderedValues.Count(); i++) {
+          var row = stringConvertibleMatrixView.DataGridView.Rows[orderedValues.ElementAt(i).Key];
+
+          int r = (int)Math.Round((double)i / (double)orderedValues.Count() * 255.0);
+          int g = (int)Math.Round(((double)orderedValues.Count() - (double)i) / (double)orderedValues.Count() * 255.0);
+
+          Color color = Color.FromArgb(r, g, 0);
+          row.DefaultCellStyle.ForeColor = color;
+        }
+      }
+    }
   }
 }
Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.designer.cs
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.designer.cs	(revision 9086)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.designer.cs	(revision 9087)
@@ -52,10 +52,11 @@
       this.addLineToChart = new System.Windows.Forms.Button();
       this.addValuesButton = new System.Windows.Forms.Button();
+      this.colorButton = new System.Windows.Forms.Button();
       this.SuspendLayout();
       // 
       // stringConvertibleMatrixView
       // 
-      this.stringConvertibleMatrixView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.stringConvertibleMatrixView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.stringConvertibleMatrixView.Caption = "StringConvertibleMatrix View";
@@ -71,5 +72,5 @@
       // dataRowComboBox
       // 
-      this.dataRowComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+      this.dataRowComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.dataRowComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
@@ -101,5 +102,5 @@
       // dataTableComboBox
       // 
-      this.dataTableComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+      this.dataTableComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.dataTableComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
@@ -133,6 +134,18 @@
       this.addValuesButton.Click += new System.EventHandler(this.addValuesButton_Click);
       // 
+      // colorButton
+      // 
+      this.colorButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.colorButton.Location = new System.Drawing.Point(200, 359);
+      this.colorButton.Name = "colorButton";
+      this.colorButton.Size = new System.Drawing.Size(75, 23);
+      this.colorButton.TabIndex = 11;
+      this.colorButton.Text = "Color Rows";
+      this.colorButton.UseVisualStyleBackColor = true;
+      this.colorButton.Click += new System.EventHandler(this.colorButton_Click);
+      // 
       // RunCollectionStatisticalTabularView
       // 
+      this.Controls.Add(this.colorButton);
       this.Controls.Add(this.addValuesButton);
       this.Controls.Add(this.addLineToChart);
@@ -157,4 +170,5 @@
     private System.Windows.Forms.Button addLineToChart;
     private System.Windows.Forms.Button addValuesButton;
+    private System.Windows.Forms.Button colorButton;
   }
 }