Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj	(revision 9087)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj	(revision 9095)
@@ -59,20 +59,8 @@
       <Private>False</Private>
     </Reference>
-    <Reference Include="HeuristicLab.Core.Views-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <Private>False</Private>
-    </Reference>
     <Reference Include="HeuristicLab.Data-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <Private>False</Private>
     </Reference>
-    <Reference Include="HeuristicLab.Data.Views-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <Private>False</Private>
-    </Reference>
     <Reference Include="HeuristicLab.Encodings.PermutationEncoding-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.MainForm-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.MainForm.WindowsForms-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <Private>False</Private>
     </Reference>
@@ -89,9 +77,4 @@
     </Reference>
     <Reference Include="HeuristicLab.Optimization.Views-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.Optimizer-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Optimizer-3.3.dll</HintPath>
       <Private>False</Private>
     </Reference>
@@ -137,10 +120,4 @@
     <Compile Include="VariableRemover.cs" />
     <Compile Include="LinearLeastSquaresFitting.cs" />
-    <Compile Include="RunCollectionStatisticalTabularView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="RunCollectionStatisticalTabularView.designer.cs">
-      <DependentUpon>RunCollectionStatisticalTabularView.cs</DependentUpon>
-    </Compile>
     <Compile Include="ScatterPlotHelper.cs" />
     <Compile Include="DataTableHelper.cs" />
@@ -151,11 +128,4 @@
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="VariableDuplicator.cs" />
-    <Compile Include="Views\SuccessorConfigurator.cs">
-      <SubType>Form</SubType>
-    </Compile>
-    <Compile Include="Views\SuccessorConfigurator.Designer.cs">
-      <DependentUpon>SuccessorConfigurator.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Views\SuccessorConfiguratorMenuItem.cs" />
     <Compile Include="WeightedParentsQualityComparer.cs" />
   </ItemGroup>
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/Plugin.cs.frame
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/Plugin.cs.frame	(revision 9087)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/Plugin.cs.frame	(revision 9095)
@@ -29,7 +29,5 @@
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
-  [PluginDependency("HeuristicLab.Core.Views", "3.3")]
   [PluginDependency("HeuristicLab.Data", "3.3")]
-  [PluginDependency("HeuristicLab.Data.Views", "3.3")]
   [PluginDependency("HeuristicLab.Encodings.PermutationEncoding", "3.3")]
   [PluginDependency("HeuristicLab.Operators", "3.3")]
@@ -38,7 +36,4 @@
   [PluginDependency("HeuristicLab.Parameters", "3.3")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
-  [PluginDependency("HeuristicLab.Optimizer", "3.3")]
-  [PluginDependency("HeuristicLab.MainForm", "3.3")]
-  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
   public class HeuristicLabAnalysisAlgorithmBehaviorAnalyzersPlugin : PluginBase {
   }
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.cs	(revision 9087)
+++ 	(revision )
@@ -1,292 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Drawing;
-using System.Linq;
-using System.Windows.Forms;
-using HeuristicLab.Analysis.AlgorithmBehavior.Analyzers;
-using HeuristicLab.Common;
-using HeuristicLab.Core.Views;
-using HeuristicLab.Data;
-using HeuristicLab.MainForm;
-using HeuristicLab.Optimization;
-
-namespace HeuristicLab.Analysis.AlgorithmBehavior {
-  [View("RunCollection Statistical Tabular View")]
-  [Content(typeof(RunCollection), false)]
-  public sealed partial class RunCollectionStatisticalTabularView : ItemView {
-    public RunCollectionStatisticalTabularView() {
-      InitializeComponent();
-      stringConvertibleMatrixView.DataGridView.RowHeaderMouseDoubleClick += new DataGridViewCellMouseEventHandler(DataGridView_RowHeaderMouseDoubleClick);
-    }
-
-    void DataGridView_RowHeaderMouseDoubleClick(object sender, DataGridViewCellMouseEventArgs e) {
-      if (e.RowIndex >= 0) {
-        IRun run = Content.ElementAt(e.RowIndex);
-        IContentView view = MainFormManager.MainForm.ShowContent(run);
-        if (view != null) {
-          view.ReadOnly = this.ReadOnly;
-          view.Locked = this.Locked;
-        }
-      }
-    }
-
-    public new RunCollection Content {
-      get { return (RunCollection)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public override bool ReadOnly {
-      get { return true; }
-      set { /*not needed because results are always readonly */}
-    }
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      dataTableComboBox.Items.Clear();
-      dataRowComboBox.Items.Clear();
-
-      if (Content != null) {
-        UpdateDataTableComboBox();
-      }
-    }
-
-    #region events
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      Content.ItemsAdded += new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_ItemsAdded);
-      Content.ItemsRemoved += new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_ItemsRemoved);
-      Content.CollectionReset += new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_CollectionReset);
-
-      RegisterRunEvents(Content);
-    }
-
-    private void RegisterRunEvents(IEnumerable<IRun> runs) {
-      foreach (IRun run in runs)
-        run.Changed += new EventHandler(run_Changed);
-    }
-
-    protected override void DeregisterContentEvents() {
-      base.DeregisterContentEvents();
-      Content.ItemsAdded -= new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_ItemsAdded);
-      Content.ItemsRemoved -= new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_ItemsRemoved);
-      Content.CollectionReset -= new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_CollectionReset);
-
-      DeregisterRunEvents(Content);
-    }
-
-    private void DeregisterRunEvents(IEnumerable<IRun> runs) {
-      foreach (IRun run in runs)
-        run.Changed -= new EventHandler(run_Changed);
-    }
-
-    private void Content_CollectionReset(object sender, HeuristicLab.Collections.CollectionItemsChangedEventArgs<IRun> e) {
-      DeregisterRunEvents(e.OldItems);
-      RegisterRunEvents(e.Items);
-      RebuildCombinedDataTable();
-    }
-
-    private void Content_ItemsRemoved(object sender, HeuristicLab.Collections.CollectionItemsChangedEventArgs<IRun> e) {
-      DeregisterRunEvents(e.Items);
-      RebuildCombinedDataTable();
-    }
-
-    private void Content_ItemsAdded(object sender, HeuristicLab.Collections.CollectionItemsChangedEventArgs<IRun> e) {
-      RegisterRunEvents(e.Items);
-      RebuildCombinedDataTable();
-    }
-
-    private void run_Changed(object sender, EventArgs e) {
-      if (InvokeRequired)
-        this.Invoke(new EventHandler(run_Changed), sender, e);
-      else {
-        IRun run = (IRun)sender;
-        UpdateRun(run);
-      }
-    }
-    #endregion
-
-    private void UpdateRun(IRun run) {
-      //TODO: hacky di hack... this is baaaadddd
-      RebuildCombinedDataTable();
-    }
-
-    private void dataTableComboBox_SelectedIndexChanged(object sender, EventArgs e) {
-      UpdateDataRowComboBox();
-    }
-
-    private void dataRowComboBox_SelectedIndexChanged(object sender, EventArgs e) {
-      RebuildCombinedDataTable();
-    }
-
-    private void UpdateDataRowComboBox() {
-      dataRowComboBox.Items.Clear();
-      var resultName = (string)dataTableComboBox.SelectedItem;
-      var dataTables = from run in Content
-                       where run.Results.ContainsKey(resultName)
-                       select run.Results[resultName] as DataTable;
-      var rowNames = (from dataTable in dataTables
-                      from row in dataTable.Rows
-                      select row.Name).Distinct().ToArray();
-
-      dataRowComboBox.Items.AddRange(rowNames);
-      if (dataRowComboBox.Items.Count > 0) dataRowComboBox.SelectedItem = dataRowComboBox.Items[0];
-    }
-
-    private void UpdateDataTableComboBox() {
-      dataTableComboBox.Items.Clear();
-      var dataTables = (from run in Content
-                        from result in run.Results
-                        where result.Value is DataTable
-                        select result.Key).Distinct().ToArray();
-
-      dataTableComboBox.Items.AddRange(dataTables);
-      if (dataTableComboBox.Items.Count > 0) dataTableComboBox.SelectedItem = dataTableComboBox.Items[0];
-    }
-
-    private void RebuildCombinedDataTable() {
-      string resultName = (string)dataTableComboBox.SelectedItem;
-      string rowName = (string)dataRowComboBox.SelectedItem;
-
-      string[] columnNames = new string[] { "Count", "Minimum", "Maximum", "Average", "Median", "Standard Deviation", "Variance", "25th Percentile", "75th Percentile", "Gradient", "Relative Error", "Avg. of Upper 25 %", " Avg. of Lower 25 %", "Avg. of First 25 %", "Avg. of Last 25 %" };
-
-      var runs = Content.Where(x => x.Results.ContainsKey(resultName));
-
-      StringMatrix dt = new StringMatrix(runs.Count(), columnNames.Count());
-      dt.RowNames = runs.Select(x => x.Name);
-      dt.ColumnNames = columnNames;
-
-      int i = 0;
-      foreach (Run run in runs) {
-        DataTable resTable = (DataTable)run.Results[resultName];
-        DataRow row = resTable.Rows[rowName];
-        var values = row.Values.AsEnumerable();
-
-        double cnt = values.Count();
-        double min = values.Min();
-        double max = values.Max();
-        double avg = values.Average();
-        double median = values.Median();
-        double stdDev = values.StandardDeviation();
-        double variance = values.Variance();
-        double percentile25 = values.Percentile(0.25);
-        double percentile75 = values.Percentile(0.75);
-        double k, d, r;
-        LinearLeastSquaresFitting.Calculate(values.ToArray(), out k, out d);
-        r = LinearLeastSquaresFitting.CalculateError(values.ToArray(), k, d);
-        double lowerAvg = values.OrderBy(x => x).Take((int)(values.Count() * 0.25)).Average();
-        double upperAvg = values.OrderByDescending(x => x).Take((int)(values.Count() * 0.25)).Average();
-        double firstAvg = values.Take((int)(values.Count() * 0.25)).Average();
-        double lastAvg = values.Skip((int)(values.Count() * 0.75)).Average();
-
-        dt[i, 0] = cnt.ToString();
-        dt[i, 1] = min.ToString();
-        dt[i, 2] = max.ToString();
-        dt[i, 3] = avg.ToString();
-        dt[i, 4] = median.ToString();
-        dt[i, 5] = stdDev.ToString();
-        dt[i, 6] = variance.ToString();
-        dt[i, 7] = percentile25.ToString();
-        dt[i, 8] = percentile75.ToString();
-        dt[i, 9] = k.ToString();
-        dt[i, 10] = r.ToString();
-        dt[i, 11] = upperAvg.ToString();
-        dt[i, 12] = lowerAvg.ToString();
-        dt[i, 13] = firstAvg.ToString();
-        dt[i, 14] = lastAvg.ToString();
-
-        i++;
-      }
-
-      stringConvertibleMatrixView.Content = dt;
-    }
-
-    private void addLineToChart_Click(object sender, EventArgs e) {
-      string resultName = (string)dataTableComboBox.SelectedItem;
-      string rowName = (string)dataRowComboBox.SelectedItem;
-      var runs = Content.Where(x => x.Results.ContainsKey(resultName));
-
-      foreach (Run run in runs) {
-        DataTable resTable = (DataTable)run.Results[resultName];
-        DataRow row = resTable.Rows[rowName];
-        var values = row.Values.ToArray();
-        double k, d;
-        LinearLeastSquaresFitting.Calculate(values, out k, out d);
-
-        DataRow newRow = new DataRow(row.Name + " Fitted Line");
-        for (int i = 0; i < values.Count(); i++) {
-          newRow.Values.Add(k * i + d);
-        }
-
-        if (!resTable.Rows.ContainsKey(newRow.Name))
-          resTable.Rows.Add(newRow);
-      }
-    }
-
-    private void addValuesButton_Click(object sender, EventArgs e) {
-      string resultName = (string)dataTableComboBox.SelectedItem;
-      string rowName = (string)dataRowComboBox.SelectedItem;
-      var runs = Content.Where(x => x.Results.ContainsKey(resultName));
-      StringMatrix sm = (StringMatrix)stringConvertibleMatrixView.Content;
-
-      for (int i = 0; i < runs.Count(); i++) {
-        IRun run = runs.ElementAt(i);
-
-        for (int j = 0; j < sm.ColumnNames.Count(); j++) {
-          string newResultName = resultName + " " + rowName + " " + sm.ColumnNames.ElementAt(j);
-          if (!run.Results.ContainsKey(newResultName))
-            run.Results.Add(new KeyValuePair<string, Core.IItem>(newResultName, new DoubleValue(double.Parse(sm[i, j]))));
-        }
-      }
-      //update column names of run collection
-      Content.Modify();
-    }
-
-    private void colorButton_Click(object sender, EventArgs e) {
-      string resultName = (string)dataTableComboBox.SelectedItem;
-      string rowName = (string)dataRowComboBox.SelectedItem;
-      var runs = Content.Where(x => x.Results.ContainsKey(resultName));
-      Dictionary<int, double> values = new Dictionary<int, double>();
-
-      if (stringConvertibleMatrixView.DataGridView.CurrentCell != null) {
-        int curIndex = stringConvertibleMatrixView.DataGridView.CurrentCell.ColumnIndex;
-
-        for (int i = 0; i < stringConvertibleMatrixView.Content.Rows; i++) {
-          values[i] = double.Parse(stringConvertibleMatrixView.Content.GetValue(i, curIndex));
-        }
-
-        var orderedValues = values.OrderBy(x => x.Value);
-
-        for (int i = 0; i < orderedValues.Count(); i++) {
-          var row = stringConvertibleMatrixView.DataGridView.Rows[orderedValues.ElementAt(i).Key];
-
-          int r = (int)Math.Round((double)i / (double)orderedValues.Count() * 255.0);
-          int g = (int)Math.Round(((double)orderedValues.Count() - (double)i) / (double)orderedValues.Count() * 255.0);
-
-          Color color = Color.FromArgb(r, g, 0);
-          row.DefaultCellStyle.ForeColor = color;
-        }
-      }
-    }
-  }
-}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.designer.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.designer.cs	(revision 9087)
+++ 	(revision )
@@ -1,174 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Analysis.AlgorithmBehavior {
-  partial class RunCollectionStatisticalTabularView {
-    /// <summary>
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary>
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Windows Form Designer generated code
-
-    /// <summary>
-    /// Required method for Designer support - do not modify
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.stringConvertibleMatrixView = new HeuristicLab.Data.Views.StringConvertibleMatrixView();
-      this.dataRowComboBox = new System.Windows.Forms.ComboBox();
-      this.label2 = new System.Windows.Forms.Label();
-      this.label1 = new System.Windows.Forms.Label();
-      this.dataTableComboBox = new System.Windows.Forms.ComboBox();
-      this.addLineToChart = new System.Windows.Forms.Button();
-      this.addValuesButton = new System.Windows.Forms.Button();
-      this.colorButton = new System.Windows.Forms.Button();
-      this.SuspendLayout();
-      // 
-      // stringConvertibleMatrixView
-      // 
-      this.stringConvertibleMatrixView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.stringConvertibleMatrixView.Caption = "StringConvertibleMatrix View";
-      this.stringConvertibleMatrixView.Content = null;
-      this.stringConvertibleMatrixView.Location = new System.Drawing.Point(3, 59);
-      this.stringConvertibleMatrixView.Name = "stringConvertibleMatrixView";
-      this.stringConvertibleMatrixView.ReadOnly = false;
-      this.stringConvertibleMatrixView.ShowRowsAndColumnsTextBox = true;
-      this.stringConvertibleMatrixView.ShowStatisticalInformation = true;
-      this.stringConvertibleMatrixView.Size = new System.Drawing.Size(492, 294);
-      this.stringConvertibleMatrixView.TabIndex = 0;
-      // 
-      // dataRowComboBox
-      // 
-      this.dataRowComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.dataRowComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.dataRowComboBox.FormattingEnabled = true;
-      this.dataRowComboBox.Location = new System.Drawing.Point(71, 33);
-      this.dataRowComboBox.Name = "dataRowComboBox";
-      this.dataRowComboBox.Size = new System.Drawing.Size(424, 21);
-      this.dataRowComboBox.TabIndex = 8;
-      this.dataRowComboBox.SelectedIndexChanged += new System.EventHandler(this.dataRowComboBox_SelectedIndexChanged);
-      // 
-      // label2
-      // 
-      this.label2.AutoSize = true;
-      this.label2.Location = new System.Drawing.Point(5, 36);
-      this.label2.Name = "label2";
-      this.label2.Size = new System.Drawing.Size(55, 13);
-      this.label2.TabIndex = 7;
-      this.label2.Text = "DataRow:";
-      // 
-      // label1
-      // 
-      this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(5, 6);
-      this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(60, 13);
-      this.label1.TabIndex = 6;
-      this.label1.Text = "DataTable:";
-      // 
-      // dataTableComboBox
-      // 
-      this.dataTableComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.dataTableComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.dataTableComboBox.FormattingEnabled = true;
-      this.dataTableComboBox.Location = new System.Drawing.Point(71, 3);
-      this.dataTableComboBox.Name = "dataTableComboBox";
-      this.dataTableComboBox.Size = new System.Drawing.Size(424, 21);
-      this.dataTableComboBox.TabIndex = 5;
-      this.dataTableComboBox.SelectedIndexChanged += new System.EventHandler(this.dataTableComboBox_SelectedIndexChanged);
-      // 
-      // addLineToChart
-      // 
-      this.addLineToChart.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
-      this.addLineToChart.Location = new System.Drawing.Point(420, 359);
-      this.addLineToChart.Name = "addLineToChart";
-      this.addLineToChart.Size = new System.Drawing.Size(75, 23);
-      this.addLineToChart.TabIndex = 9;
-      this.addLineToChart.Text = "Fit Line";
-      this.addLineToChart.UseVisualStyleBackColor = true;
-      this.addLineToChart.Click += new System.EventHandler(this.addLineToChart_Click);
-      // 
-      // addValuesButton
-      // 
-      this.addValuesButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
-      this.addValuesButton.Location = new System.Drawing.Point(281, 359);
-      this.addValuesButton.Name = "addValuesButton";
-      this.addValuesButton.Size = new System.Drawing.Size(133, 23);
-      this.addValuesButton.TabIndex = 10;
-      this.addValuesButton.Text = "Add Values to Results";
-      this.addValuesButton.UseVisualStyleBackColor = true;
-      this.addValuesButton.Click += new System.EventHandler(this.addValuesButton_Click);
-      // 
-      // colorButton
-      // 
-      this.colorButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
-      this.colorButton.Location = new System.Drawing.Point(200, 359);
-      this.colorButton.Name = "colorButton";
-      this.colorButton.Size = new System.Drawing.Size(75, 23);
-      this.colorButton.TabIndex = 11;
-      this.colorButton.Text = "Color Rows";
-      this.colorButton.UseVisualStyleBackColor = true;
-      this.colorButton.Click += new System.EventHandler(this.colorButton_Click);
-      // 
-      // RunCollectionStatisticalTabularView
-      // 
-      this.Controls.Add(this.colorButton);
-      this.Controls.Add(this.addValuesButton);
-      this.Controls.Add(this.addLineToChart);
-      this.Controls.Add(this.dataRowComboBox);
-      this.Controls.Add(this.label2);
-      this.Controls.Add(this.label1);
-      this.Controls.Add(this.dataTableComboBox);
-      this.Controls.Add(this.stringConvertibleMatrixView);
-      this.Name = "RunCollectionStatisticalTabularView";
-      this.Size = new System.Drawing.Size(498, 385);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-    #endregion
-
-    private Data.Views.StringConvertibleMatrixView stringConvertibleMatrixView;
-    private System.Windows.Forms.ComboBox dataRowComboBox;
-    private System.Windows.Forms.Label label2;
-    private System.Windows.Forms.Label label1;
-    private System.Windows.Forms.ComboBox dataTableComboBox;
-    private System.Windows.Forms.Button addLineToChart;
-    private System.Windows.Forms.Button addValuesButton;
-    private System.Windows.Forms.Button colorButton;
-  }
-}