Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessClassification.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessClassification.cs	(revision 9096)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessClassification.cs	(revision 9098)
@@ -53,8 +53,8 @@
 
     #region parameter properties
-    public IConstrainedValueParameter<IGaussianProcessClassificationModelCreator> ModelCreatorParameter {
+    public IConstrainedValueParameter<IGaussianProcessClassificationModelCreator> GaussianProcessModelCreatorParameter {
       get { return (IConstrainedValueParameter<IGaussianProcessClassificationModelCreator>)Parameters[ModelCreatorParameterName]; }
     }
-    public IFixedValueParameter<GaussianProcessClassificationSolutionCreator> SolutionCreatorParameter {
+    public IFixedValueParameter<GaussianProcessClassificationSolutionCreator> GaussianProcessSolutionCreatorParameter {
       get { return (IFixedValueParameter<GaussianProcessClassificationSolutionCreator>)Parameters[SolutionCreatorParameterName]; }
     }
@@ -87,5 +87,5 @@
 
       ParameterizedModelCreators();
-      ParameterizeSolutionCreator(SolutionCreatorParameter.Value);
+      ParameterizeSolutionCreator(GaussianProcessSolutionCreatorParameter.Value);
       RegisterEventHandlers();
     }
@@ -103,14 +103,14 @@
     #region events
     private void RegisterEventHandlers() {
-      ModelCreatorParameter.ValueChanged += ModelCreatorParameter_ValueChanged;
+      GaussianProcessModelCreatorParameter.ValueChanged += ModelCreatorParameter_ValueChanged;
     }
 
     private void ModelCreatorParameter_ValueChanged(object sender, EventArgs e) {
-      ParameterizedModelCreator(ModelCreatorParameter.Value);
+      ParameterizedModelCreator(GaussianProcessModelCreatorParameter.Value);
     }
     #endregion
 
     private void ParameterizedModelCreators() {
-      foreach (var creator in ModelCreatorParameter.ValidValues) {
+      foreach (var creator in GaussianProcessModelCreatorParameter.ValidValues) {
         ParameterizedModelCreator(creator);
       }
Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessRegression.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessRegression.cs	(revision 9096)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessRegression.cs	(revision 9098)
@@ -53,8 +53,8 @@
 
     #region parameter properties
-    public IConstrainedValueParameter<IGaussianProcessRegressionModelCreator> ModelCreatorParameter {
+    public IConstrainedValueParameter<IGaussianProcessRegressionModelCreator> GaussianProcessModelCreatorParameter {
       get { return (IConstrainedValueParameter<IGaussianProcessRegressionModelCreator>)Parameters[ModelCreatorParameterName]; }
     }
-    public IFixedValueParameter<GaussianProcessRegressionSolutionCreator> SolutionCreatorParameter {
+    public IFixedValueParameter<GaussianProcessRegressionSolutionCreator> GaussianProcessSolutionCreatorParameter {
       get { return (IFixedValueParameter<GaussianProcessRegressionSolutionCreator>)Parameters[SolutionCreatorParameterName]; }
     }
@@ -87,5 +87,5 @@
 
       ParameterizedModelCreators();
-      ParameterizeSolutionCreator(SolutionCreatorParameter.Value);
+      ParameterizeSolutionCreator(GaussianProcessSolutionCreatorParameter.Value);
       RegisterEventHandlers();
     }
@@ -103,14 +103,14 @@
     #region events
     private void RegisterEventHandlers() {
-      ModelCreatorParameter.ValueChanged += ModelCreatorParameter_ValueChanged;
+      GaussianProcessModelCreatorParameter.ValueChanged += ModelCreatorParameter_ValueChanged;
     }
 
     private void ModelCreatorParameter_ValueChanged(object sender, EventArgs e) {
-      ParameterizedModelCreator(ModelCreatorParameter.Value);
+      ParameterizedModelCreator(GaussianProcessModelCreatorParameter.Value);
     }
     #endregion
 
     private void ParameterizedModelCreators() {
-      foreach (var creator in ModelCreatorParameter.ValidValues) {
+      foreach (var creator in GaussianProcessModelCreatorParameter.ValidValues) {
         ParameterizedModelCreator(creator);
       }