Index: /trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobListView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobListView.cs	(revision 9106)
+++ /trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobListView.cs	(revision 9107)
@@ -50,5 +50,5 @@
 
     protected override RefreshableJob CreateItem() {
-      var refreshableJob = new RefreshableJob() { IsAllowedPrivileged = HiveClient.Instance.IsAllowedPrivileged };
+      var refreshableJob = new RefreshableJob();
       refreshableJob.Job.Name = "New Hive Job";
       return refreshableJob;
Index: /trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.Designer.cs	(revision 9106)
+++ /trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.Designer.cs	(revision 9107)
@@ -375,5 +375,5 @@
       this.toolTip.SetToolTip(this.isPrivilegedCheckBox, "If checked, the task will be executed in a privileged sandbox on the slave.");
       this.isPrivilegedCheckBox.UseVisualStyleBackColor = true;
-      this.isPrivilegedCheckBox.Validated += new System.EventHandler(this.isPrivilegedCheckBox_Validated);
+      this.isPrivilegedCheckBox.CheckedChanged += new System.EventHandler(this.isPrivilegedCheckBox_CheckChanged);
       // 
       // refreshAutomaticallyCheckBox
Index: /trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs	(revision 9106)
+++ /trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs	(revision 9107)
@@ -140,5 +140,5 @@
           executionTimeTextBox.Text = Content.ExecutionTime.ToString();
           resourceNamesTextBox.Text = Content.Job.ResourceNames;
-          isPrivilegedCheckBox.Checked = Content.Job.IsPrivileged;
+          isPrivilegedCheckBox.Checked = Content.IsAllowedPrivileged;
           refreshAutomaticallyCheckBox.Checked = Content.RefreshAutomatically;
           logView.Content = Content.Log;
@@ -178,5 +178,5 @@
         this.jobsTreeView.ReadOnly = !Content.IsControllable || Content.ExecutionState != ExecutionState.Prepared || alreadyUploaded || Content.IsProgressing;
 
-        this.isPrivilegedCheckBox.Enabled = Content.IsAllowedPrivileged && Content.IsControllable && !(Content.ExecutionState != ExecutionState.Prepared || alreadyUploaded) && !Content.IsProgressing;
+        this.isPrivilegedCheckBox.Enabled = HiveClient.Instance.IsAllowedPrivileged && Content.IsControllable && !(Content.ExecutionState != ExecutionState.Prepared || alreadyUploaded) && !Content.IsProgressing;
         this.refreshAutomaticallyCheckBox.Enabled = Content.IsControllable && alreadyUploaded && jobsLoaded && Content.ExecutionState == ExecutionState.Started && !Content.IsProgressing;
         this.refreshButton.Enabled = Content.IsDownloadable && alreadyUploaded && !Content.IsProgressing;
@@ -345,4 +345,5 @@
         Invoke(new EventHandler(Content_IsAllowedPrivilegedChanged), sender, e);
       else {
+        isPrivilegedCheckBox.Checked = Content.IsAllowedPrivileged;
         SetEnabledStateOfControls();
       }
@@ -447,6 +448,6 @@
     }
 
-    private void isPrivilegedCheckBox_Validated(object sender, EventArgs e) {
-      if (Content != null && !SuppressEvents) Content.Job.IsPrivileged = isPrivilegedCheckBox.Checked;
+    private void isPrivilegedCheckBox_CheckChanged(object sender, EventArgs e) {
+      if (Content != null && !SuppressEvents) Content.IsAllowedPrivileged = isPrivilegedCheckBox.Checked;
     }
 
Index: /trunk/sources/HeuristicLab.Clients.Hive/3.3/HiveClient.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive/3.3/HiveClient.cs	(revision 9106)
+++ /trunk/sources/HeuristicLab.Clients.Hive/3.3/HiveClient.cs	(revision 9107)
@@ -83,5 +83,5 @@
 
       try {
-        this.IsAllowedPrivileged = HiveServiceLocator.Instance.CallHiveService((s) => s.IsAllowedPrivileged());
+        IsAllowedPrivileged = HiveServiceLocator.Instance.CallHiveService((s) => s.IsAllowedPrivileged());
 
         var oldJobs = jobs ?? new ItemCollection<RefreshableJob>();
Index: /trunk/sources/HeuristicLab.Clients.Hive/3.3/RefreshableJob.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive/3.3/RefreshableJob.cs	(revision 9106)
+++ /trunk/sources/HeuristicLab.Clients.Hive/3.3/RefreshableJob.cs	(revision 9107)
@@ -158,10 +158,9 @@
 
     // may execute jobs with privileged permissions on slaves
-    private bool isAllowedPrivileged = true;
     public bool IsAllowedPrivileged {
-      get { return isAllowedPrivileged; }
+      get { return Job.IsPrivileged; }
       set {
-        if (value != isAllowedPrivileged) {
-          isAllowedPrivileged = value;
+        if (value != Job.IsPrivileged) {
+          Job.IsPrivileged = value;
           OnIsAllowedPrivilegedChanged();
         }
Index: /trunk/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Job.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Job.cs	(revision 9106)
+++ /trunk/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Job.cs	(revision 9107)
@@ -35,7 +35,7 @@
     #region Constructors and Cloning
     public Job() {
-      this.ResourceNames = "HEAL";
-      this.DateCreated = DateTime.Now;
-      this.Permission = Permission.Full;
+      ResourceNames = "HEAL";
+      DateCreated = DateTime.Now;
+      Permission = Permission.Full;
     }
 